<?
/**
 * TorrentTrader v1.0.2 LITE
 *  - Coded by Sqrtboy (sqrtboy@phpsoft.org)
 *  - Released under the GPL licence
 *  - Support/Hacks/Discussion @ http://www.torrenttrader.com
 **/
  ob_start('ob_gzhandler');
  require_once("functions.php");


  function benc($obj) {
	if (!is_array($obj) || !isset($obj["type"]) || !isset($obj["value"]))
		return;
	$c = $obj["value"];
	switch ($obj["type"]) {
		case "string":
			return benc_str($c);
		case "integer":
			return benc_int($c);
		case "list":
			return benc_list($c);
		case "dictionary":
			return benc_dict($c);
		default:
			return;
		}
	}

	function benc_str($s) {
	    return strlen($s) . ":$s";
	}

	function benc_int($i) {
	    return "i" . $i . "e";
	}

	function benc_list($a) {
	    $s = "l";
	    foreach ($a as $e) {
	        $s .= benc($e);
	    }
	    $s .= "e";
	    return $s;
	}

	function benc_dict($d) {
	    $s = "d";
	    $keys = array_keys($d);
	    sort($keys);
	    foreach ($keys as $k) {
	        $v = $d[$k];
	        $s .= benc_str($k);
	        $s .= benc($v);
	    }
	    $s .= "e";
	    return $s;
	}

	function bdec_file($f, $ms) {
	    $fp = fopen($f, "rb");
	    if (!$fp)
	        return;
	    $e = fread($fp, $ms);
	    fclose($fp);
	    return bdec($e);
	}

	function bdec($s) {
	    if (preg_match('/^(\d+):/', $s, $m)) {
	        $l = $m[1];
	        $pl = strlen($l) + 1;
	        $v = substr($s, $pl, $l);
	        $ss = substr($s, 0, $pl + $l);
	        if (strlen($v) != $l)
	            return;
	        return array(type => "string", value => $v, strlen => strlen($ss), string => $ss);
	    }
	    if (preg_match('/^i(\d+)e/', $s, $m)) {
	        $v = $m[1];
	        $ss = "i" . $v . "e";
	        if ($v === "-0")
	            return;
	        if ($v[0] == "0" && strlen($v) != 1)
	            return;
	        return array(type => "integer", value => $v, strlen => strlen($ss), string => $ss);
	    }
	    switch ($s[0]) {
	        case "l":
	            return bdec_list($s);
	        case "d":
	            return bdec_dict($s);
	        default:
	            return;
	    }
	}

	function bdec_list($s) {
	    if ($s[0] != "l")
	        return;
	    $sl = strlen($s);
	    $i = 1;
	    $v = array();
	    $ss = "l";
	    for (;;) {
	        if ($i >= $sl)
	            return;
	        if ($s[$i] == "e")
	            break;
	        $ret = bdec(substr($s, $i));
	        if (!isset($ret) || !is_array($ret))
	            return;
	        $v[] = $ret;
	        $i += $ret["strlen"];
	        $ss .= $ret["string"];
	    }
	    $ss .= "e";
	    return array(type => "list", value => $v, strlen => strlen($ss), string => $ss);
	}

	function bdec_dict($s) {
	    if ($s[0] != "d")
	        return;
	    $sl = strlen($s);
	    $i = 1;
	    $v = array();
	    $ss = "d";
	    for (;;) {
	        if ($i >= $sl)
	            return;
	        if ($s[$i] == "e")
	            break;
	        $ret = bdec(substr($s, $i));
	        if (!isset($ret) || !is_array($ret) || $ret["type"] != "string")
	            return;
	        $k = $ret["value"];
	        $i += $ret["strlen"];
	        $ss .= $ret["string"];
	        if ($i >= $sl)
	            return;
	        $ret = bdec(substr($s, $i));
	        if (!isset($ret) || !is_array($ret))
	            return;
	        $v[$k] = $ret;
	        $i += $ret["strlen"];
	        $ss .= $ret["string"];
	    }
	    $ss .= "e";
	    return array(type => "dictionary", value => $v, strlen => strlen($ss), string => $ss);
	}

    $submit = (int)$_GET['submit'];

  require_once('functions.php');

  site_header();

  if ($submit != 1)
  {
  $submit_form = "You must post torrents with one the following announce url(s):<br>" ;
  foreach ($announce_urls as $value)
                 $submit_form .= "<li><b>$value</b></li>";
  $submit_form .= '<br><br>
  			<form enctype="multipart/form-data" action="upload.php?submit=1" method="post"><table border="0" cellspacing="0">
				<tr>
					<td>Torrent:</td>
					<td><input type="file" name="torrent" style="width:400px;"></td>
				</tr>
                <tr>
					<td>Name:</td>
					<td><input type="text" name="torrentname" style="width:400px;"></td>

				</tr>
				<tr>
					<td>Description:</td>
					<td><input type="text" name="description" style="width:400px;"></td>
				</tr>
				<tr>
					<td>Category:</td><td>
                     <select name="category" size="1" style="width:300px;">";
                        <option>All Categories</option>';

                     foreach ($categories as $value)
                        $submit_form .='<option value="'.$value.'">'.$value.'</option>';

                      $submit_form .=  '</select>
                        </td>
				</tr>
				<tr>
					<td></td>
					<td align="right"><input type="submit" name="upload_do" value="Upload" style="padding:0;background-color:#ffffc0;border:0;color:FF0000;font-weight:bold"></td>
				</tr>

			</table></form>
            <br><a href="index.php"><strong>Return to index page</strong>
            ';


  main_box('Submit .torrent to the site',$submit_form);
  }
  else
  {
  	foreach(explode(":","description:category:torrentname") as $v) {
	if ($_POST[$v] == "")
    	{
  		$message = 'Please fill in all the required input !<br><font color="red"><b>Missing parameter: '.$v.'</b></font>';
        main_box('Error',$message."<br><br><a href=\"upload.php\"><strong>Reload page</strong>");
        site_footer();
        }
  	}

  	if (!isset($_FILES["torrent"]))
    	{
  		$message = 'Please attach a torrent to be submited to site !';
        main_box('Error',$message."<br><br><a href=\"upload.php\"><strong>Reload page</strong>");
        site_footer();
        }

	  $f = $_FILES["torrent"];
	  $fname = $f["name"];
	  if (empty($fname))
      	{
  		$message ='You must select a file with a valid filename !';
        main_box('Error',$message."<br><br><a href=\"upload.php\"><strong>Reload page</strong>");
        site_footer();
        }


	  $descr = (string)($_POST["description"]);
   	  $categ = (string)$_POST["category"];
      $torrentname =  (string)$_POST["torrentname"];



	  if (!preg_match('/^(.+)\.torrent$/si', $fname, $matches))
         {
  		$message = 'The submitted file must at least have a .torrent extension';
        main_box('Error',$message."<br><br><a href=\"upload.php\"><strong>Reload page</strong>");
        site_footer();
        }

      if ($categ == "All Categories")
        {
        $message = 'You need to select a category before submitting your torrent';
        main_box('Error',$message."<br><br><a href=\"upload.php\"><strong>Reload page</strong>");
        site_footer();
        }

	  $shortfname = $matches[1];

	  $tmpname = $f["tmp_name"];
	  if (!is_uploaded_file($tmpname))
      	{
  		$message = 'The file was uploaded, but couldn\'t be found in the temporary folder of server.
        Retry uploading later or contact server administrator.';
        main_box('Error',$message."<br><br><a href=\"upload.php\"><strong>Reload page</strong>");
        site_footer();
        }

      move_uploaded_file($tmpname, "torrents/".$fname);

	  $dict = bdec_file("torrents/".$fname, filesize("torrents/".$fname));
	  if (!isset($dict))
      	{
        unlink("torrents/".$fname);
  		$message = 'The submitted file doesn\'t seem to be a valid torrent file.';
        main_box('Error',$message."<br><br><a href=\"upload.php\"><strong>Reload page</strong>");
        site_footer();
        }

	  function dict_check($d, $s) {
	    if ($d["type"] != "dictionary")
            {
            unlink("torrents/".$fname);
	        $message = "Not a bencoded dictionary";
            main_box('Error',$message."<br><br><a href=\"upload.php\"><strong>Reload page</strong>");
            site_footer();
            }
	    $a = explode(":", $s);
	    $dd = $d["value"];
	    $ret = array();
	    foreach ($a as $k) {
	        unset($t);
	        if (preg_match('/^(.*)\((.*)\)$/', $k, $m)) {
	            $k = $m[1];
	            $t = $m[2];
	        }
	        if (!isset($dd[$k]))
            {
                unlink("torrents/".$fname);
	            $message = "The dictionary is missing key(s)";
                main_box('Error',$message."<br><br><a href=\"upload.php\"><strong>Reload page</strong>");
                site_footer();
            }
	        if (isset($t)) {
	            if ($dd[$k]["type"] != $t)
                {
                    unlink("torrents/".$fname);
	                $message = "There is an invalid entry in the dictionary";
                    main_box('Error',$message."<br><br><a href=\"upload.php\"><strong>Reload page</strong>");
                    site_footer();
                }
	            $ret[] = $dd[$k]["value"];
	        }
	        else
	            $ret[] = $dd[$k];
	    }
	    return $ret;
	  }

	  function dict_get($d, $k, $t) {
	    if ($d["type"] != "dictionary")
        {
        unlink("torrents/".$fname);
        main_box('Error',$message."<br><br><a href=\"upload.php\"><strong>Reload page</strong>");
        site_footer();
	    $message = "This isn't a dictionary.";
        }
	    $dd = $d["value"];
	    if (!isset($dd[$k]))
	        return;
	    $v = $dd[$k];
	    if ($v["type"] != $t)
        {
            unlink("torrents/".$fname);
            main_box('Error',$message."<br><br><a href=\"upload.php\"><strong>Reload page</strong>");
            site_footer();
	        $message = "Invalid dictionary entry type";
        }
	    return $v["value"];
	  }

      list($ann, $info) = dict_check($dict, "announce(string):info");
      $url_ann = array() ;
      $a=0;
      $announcelist = dict_get($dict, "announce-list","list");

        if (isset($announcelist) && count($announcelist))
            {
                  foreach ($announcelist as $fn) {
                    $hi = $fn["value"];

                     for ($i=0;$i < count($hi);$i++  )
                      {
                      $url_ann[] =  $hi[$i]["value"] ;
                      }
                  }
                  for ($j=0;$j<count($announce_urls);$j++)
                   {
                  for ($k=0;$k<count($url_ann);$k++)
                  {
                  if  ($announce_urls[$j]==$url_ann[$k])  $a+=1;
                  }
                   }
                 if ($a<1)
                 {
                 unlink("torrents/".$fname);
                 $message =  "Invalid announce url! It must be one of these :<b>" ;
                 foreach ($announce_urls as $value)
                 $message .= "<li>$value</li>";
                 $message .="</b>";
                 main_box('Error',$message."<br><br><a href=\"upload.php\"><strong>Reload page</strong>");
                 site_footer();
                 }
             }
         else
            {
                 if (!in_array($ann, $announce_urls, 1))
                 {
                 unlink("torrents/".$fname);
                 $message =  "Invalid announce url! It must be one of these :<b>" ;
                 foreach ($announce_urls as $value)
                 $message .= "<li>$value</li>";
                 $message .="</b>";
                 main_box('Error',$message."<br><br><a href=\"upload.php\"><strong>Reload page</strong>");
                 site_footer();
                 }
            }
      list($dname, $plen, $pieces) = dict_check($info, "name(string):piece length(integer):pieces(string)");

      $filelist = array();
      $totallen = dict_get($info, "length", "integer");
        if (isset($totallen)) {
          $filelist[] = array($dname, $totallen);
          $type = "single";
        }
        else {
          $flist = dict_get($info, "files", "list");
          if (!isset($flist))
          {
              unlink("torrents/".$fname);
              $message = "Missing both length and files";
              main_box('Error',$message."<br><br><a href=\"upload.php\"><strong>Reload page</strong>");
              site_footer();
          }
          if (!count($flist))
          {
          $message = "No files";
          unlink("torrents/".$fname);
          main_box('Error',$message."<br><br><a href=\"upload.php\"><strong>Reload page</strong>");
          site_footer();
          }
          $totallen = 0;
          foreach ($flist as $fn) {
              list($ll, $ff) = dict_check($fn, "length(integer):path(list)");
              $totallen += $ll;
              $ffa = array();
              foreach ($ff as $ffe) {
                  if ($ffe["type"] != "string")
                      $message = "Filename error";
                  $ffa[] = $ffe["value"];
              }
              if (!count($ffa))
                  $message = "Filename error";
              $ffe = implode("/", $ffa);
              $filelist[] = array($ffe, $ll);
          }
          $type = "multi";
        }

      $tmphex = sha1($info["string"]);
      $hexhash = strtolower($tmphex);

   	  if (strlen($hexhash) != 40)
         {
             unlink("torrents/".$fname); 
             $message = 'The info_hash of this torrent is invalid: it must be 40 bytes long exactly !';
             main_box('Error',$message."<br><br><a href=\"upload.php\"><strong>Reload page</strong>");
             site_footer();
         }




        // we insert the torrent into the database
        if (!file_exists('data/torrents.dat'))
        {
        touch('data/torrents.dat');
        }


        $source = fopen('data/torrents.dat','r+');
        flock($source, LOCK_EX) ;

        // we first check the torrent was not already added
        while ($info = fscanf ($source, "%s %s %s %d %d %s %s %d %d %d %d\n")) {
        list ($prev_info_hash, $prev_filename, $prev_name,$prev_size,$prev_numfiles,$prev_descr,$prev_category,$seeders,$leechers,$completed,$hits) = $info;
        if ($hexhash ==  $prev_info_hash)
          {
             main_box('Error','This torrent has already been uploaded to the server !<br><br><a href="upload.php"><strong>Reload page</strong>');
             flock($source, LOCK_UN);
             fclose($source);
             site_footer();
         }
         $content .= sprintf("%s %s %s %d %d %s %s %d %d %d %d\n",$prev_info_hash, $prev_filename, $prev_name,$prev_size,$prev_numfiles,$prev_descr,$prev_category,$seeders,$leechers,$completed,$hits);
        }
        // we update the hit counter for this torrent
        $content = sprintf("%s %s %s %d %d %s %s %d %d %d %d\n",$hexhash,str_replace(chr(0),"_",str_replace(" ","_",$fname)),str_replace(chr(0),"_",str_replace(" ","_",$torrentname)),$totallen,count($filelist),str_replace(chr(0),"_",str_replace(" ","_",$descr)),$categ,"0","0","0","0").$content;
        rewind($source);
        ftruncate($source,0);
        fwrite($source, $content);
        flock($source, LOCK_UN);
        fclose($source);



        rename("torrents/".$fname, "torrents/".$hexhash.".torrent");
        //move_uploaded_file($tmpname, "torrents/".$hexhash.".torrent");
        main_box('Upload successfull','Your torrent has successfully been added to our database. Thank you for your submission !<br><br><a href="index.php"><strong>Return to index page</strong>');



	  }




      site_footer();
?>