<?
/**
 * TorrentTrader v1.0.2 LITE 
 *  - Coded by Sqrtboy (sqrtboy@phpsoft.org)
 *  - Released under the GPL licence
 *  - Support/Hacks/Discussion @ http://www.torrenttrader.com
 **/


    ob_start('ob_gzhandler');
    require_once('config.php');


/*
$_GET['info_hash'] = hex2bin('9053f05a964629d064775b43bc720743be3f9239');
$_GET['ip'] = '83.10.10.10';
$_GET['port'] = rand(20, 120);
$_GET['uploaded'] = rand(20, 120000);
$_GET['downloaded'] = rand(20, 120000);
$_GET['peer_id'] = 'S588-----gqQ8TqDeqaY';
$_GET['left'] = rand(0, 3000000);
$_GET['event'] = 'started';
$_GET['numwant'] = 50;
$_GET['compact'] = 1;
*/


/*******************************************************************\
* Bencoding Functions (last edited by SqrtBoy 12-01-05 @ 17.10)      *
*  - to create bencoded data                                         *
\*******************************************************************/

    function benc($obj) {
    if (!is_array($obj) || !isset($obj["type"]) || !isset($obj["value"]))
        return;
    $c = $obj["value"];
    switch ($obj["type"]) {
        case "string":
            return benc_str($c);
        case "integer":
            return benc_int($c);
        case "list":
            return benc_list($c);
        case "dictionary":
            return benc_dict($c);
        default:
            return;
        }
    }

    function benc_str($s) {
        return strlen($s) . ":$s";
    }

    function benc_int($i) {
        return "i" . $i . "e";
    }

    function benc_list($a) {
        $s = "l";
        foreach ($a as $e) {
            $s .= benc($e);
        }
        $s .= "e";
        return $s;
    }

    function benc_dict($d) {
        $s = "d";
        $keys = array_keys($d);
        sort($keys);
        foreach ($keys as $k) {
            $v = $d[$k];
            $s .= benc_str($k);
            $s .= benc($v);
        }
        $s .= "e";
        return $s;
    }

/*******************************************************************\
* hex2bin Functions (last edited by SqrtBoy 12-01-05 @ 17.10)        *
*  - converts hex value into  ascii equivalent                       *
\*******************************************************************/

    function hex2bin($hex)
    {
            $result = '';
            for ($i = 0; $i < strlen($hex); $i += 2)
                    $result .= chr(hexdec(substr($hex,$i,2)));
            return $result;
    }



/*******************************************************************\
* Get IP Functions (last edited by SqrtBoy 12-01-05 @ 17.10)        *
*  - validip/getip courtesy of manolete (manolete@myway.com)        *
\*******************************************************************/

    function validip($ip)
    {
    	if (!empty($ip) && ip2long($ip)!=-1)
    	{
    		$reserved_ips = array (
    				array('0.0.0.0','2.255.255.255'),
    				array('10.0.0.0','10.255.255.255'),
    				array('127.0.0.0','127.255.255.255'),
    				array('169.254.0.0','169.254.255.255'),
    				array('172.16.0.0','172.31.255.255'),
    				array('192.0.2.0','192.0.2.255'),
    				array('192.168.0.0','192.168.255.255'),
    				array('255.255.255.0','255.255.255.255')
    		);

    		foreach ($reserved_ips as $r)
    		{
    				$min = ip2long($r[0]);
    				$max = ip2long($r[1]);
    				if ((ip2long($ip) >= $min) && (ip2long($ip) <= $max)) return false;
    		}
    		return true;
    	}
    	else return false;
    }

    function getip()
    {
    	global $_SERVER;
    	if (validip($_SERVER['HTTP_CLIENT_IP'])) return $_SERVER['HTTP_CLIENT_IP'];
    	elseif ($_SERVER['HTTP_X_FORWARDED_FOR']!="")
    	{
    		$forwarded=str_replace(",","",$_SERVER['HTTP_X_FORWARDED_FOR']);
    		$forwarded_array=split(" ",$forwarded);
    		foreach($forwarded_array as $value)	if (validip($value)) return $value;
    	}
    	return $_SERVER['REMOTE_ADDR'];
    }

/*******************************************************************\
* hash_pad Functions (last edited by SqrtBoy 12-01-05 @ 20.29)      *
*  - format a info_hash into a 20 bytes string                       *
\*******************************************************************/

    function hash_pad($hash) {
        return str_pad($hash, 20);
    }


/*******************************************************************\
* err Functions (last edited by SqrtBoy 12-01-05 @ 20.31)           *
*  - display an error msg                                           *
\*******************************************************************/
    function err($msg,$redirect=false)
    {
    global $siteurl;
    if ($redirect==true)
    {
    echo '<br><br><center><b><font size=4>'.$msg.'</font></b>';
    echo "<meta http-equiv='refresh' content='3;url=".$siteurl."'>";
    exit();
    }
    else
    {
    	benc_resp(array('failure reason' => array(type => 'string', value => $msg)));
        exit();
    }
    }

/*******************************************************************\
* benc_resp Functions (last edited by SqrtBoy 12-01-05 @ 20.31)      *
*                                                                    *
\*******************************************************************/

    function benc_resp($d)
    {
    	benc_resp_raw(benc(array(type => 'dictionary', value => $d)));
    }

/*******************************************************************\
* Get IP Functions (last edited by SqrtBoy 12-01-05 @ 17.10)        *
*  - validip/getip courtesy of manolete (manolete@myway.com)        *
\*******************************************************************/

    function benc_resp_raw($x)
    {
    	header('Content-Type: text/plain');
    	header('Pragma: no-cache');
    	echo $x;
        exit();
    }

    $agent = $_SERVER['HTTP_USER_AGENT'];
    // Deny access made with a browser...
    if (ereg('^Mozilla\\/', $agent) || ereg('^Opera\\/', $agent) || ereg('^Links ', $agent) || ereg('^Lynx\\/', $agent))
       err('You are being redirect to main site, please wait !',true);


    $req = 'info_hash:peer_id:!ip:port:uploaded:downloaded:left:!event';
    foreach (explode(':', $req) as $x)
    {
    	if ($x[0] == '!')
    	{
    		$x = substr($x, 1);
    		$opt = 1;
    	}
    	else
    		$opt = 0;
    	if (!isset($_GET[$x]))
    	{
    		if (!$opt)
    			err('Missing Key: '.$x);
    		continue;
    	}
        if (get_magic_quotes_gpc())
        $GLOBALS[$x] = stripslashes($_GET[$x]);
        else $GLOBALS[$x] = $_GET[$x];
    }


    foreach (array('info_hash','peer_id') as $x)
    {
    	if (strlen($GLOBALS[$x]) != 20)
    		err("Invalid $x (" . strlen($GLOBALS[$x]) . " - " . urlencode($GLOBALS[$x]) . ")");
    }

    if (empty($ip) || !preg_match('/^(\d{1,3}\.){3}\d{1,3}$/s', $ip))
    	$ip = getip();



    $num_want = 50;
    foreach(array('num want', 'numwant', 'num_want') as $k)
    {
    	if (isset($_GET[$k]))
    	{
    		$num_want = (int)$_GET[$k];
    		break;
    	}
    }

    if (!$port || $port > 0xffff)
    	err('Invalid Port');


    if (!isset($event))
    	$event = '';

    $seeder = ($left == 0) ? 1 : 0;
    // Windows compatibility section -- required for Windows servers

    if (isset($_GET['info_hash']))
    {
        $info_hash = (string)$_GET['info_hash'];
    	if (strlen($info_hash) == 20)
    		$info_hash = bin2hex($info_hash);
    	else if (strlen($info_hash) != 40)
    		err('Invalid info hash value.');
    	$info_hash = strtolower($info_hash);

    }

    $peerid = str_replace(chr(0),"_",$peerid);

    // we check if the info_hash is in database
    $source = fopen('data/torrents.dat','r+');
    flock($source, LOCK_EX) ;
    $found = 0 ;
    while ($info = fscanf ($source, "%s %s %s %d %d %s %s %d %d %d %d\n")) {
    list ($prev_info_hash, $filename, $name,$size,$numfiles,$descr,$category,$seeders,$leechers,$completed,$hits) = $info;
     if ($info_hash ==  $prev_info_hash)
      {
        // found
        $row['seeders']  = $seeders;
        $row['leechers'] = $leechers;
        $row['completed']  = $completed;
        $row['hits']  = $hits;
        $row['size']  = $size;
        $row['numfiles']  = $numfiles;
        $row['descr']  = $descr;
        $row['category']  = $category;
        $fname = $filename;
        $found += 1;
     }
    }
    flock($source, LOCK_UN);
    fclose($source);

    if ($found == 0 || file_exists('data/'.$info_hash.'.dat.lock'))
    {
    // not found
    err('Torrent not found on this tracker - hash = ' . $info_hash);
    }

    // we create it if not existing already
    if (!file_exists('data/'.$info_hash.'.dat'))
    touch('data/'.$info_hash.'.dat');

    if($_GET['compact'] != 1)
    $resp = 'd8:completei'.$row['seeders'].'e10:incompletei'.$row['leechers'].'e8:intervali'.$announce_interval.'e5:peersl' ;
    else
    $resp = 'd8:completei'.$row['seeders'].'e10:incompletei'.$row['leechers'].'e8:intervali'.$announce_interval.'e5:peers' ;

    $source = fopen('data/'.$info_hash.'.dat','r+');
    flock($source, LOCK_EX) ;
    $cnt = 0;
    while ($info = fscanf ($source, "%s %s %s %d %d %d %d %d %d\n")) {
    list ($prev_ip, $prev_info_hash, $prev_peer_id,$prev_port,$prev_seeder,$prev_uploaded,$prev_downloaded,$prev_left,$prev_last_action) = $info;

        switch ($event)
        {
            case "completed":
                $row['completed'] += 1;
            case "stopped":
                break;
            default:
                if ($cnt < $num_want)
                {
                    if($_GET['compact'] != 1)
                    {
                    $prev_peer_id = hash_pad($prev_peer_id);

                      $resp .= 'd' .
                        benc_str('ip') . benc_str($prev_ip) ;
                        if (!$_GET['no_peer_id']) {
                            $resp .= benc_str('peer id') . benc_str($prev_peer_id);
                        }
                        $resp .= benc_str('port') . benc_int($prev_port);
                        $resp .= 'e';
                    }
                    else
                    {
                    $peer_ip = explode('.', $prev_ip);
                    $peer_ip = pack('C*', $peer_ip[0], $peer_ip[1], $peer_ip[2], $peer_ip[3]);
                    $peer_port = pack('n*', (int)$prev_port);
                    $time = intval((time() % 7680) / 60);
                    if($_GET['left'] == 0)
                    $time += 128;

                    $time = pack('C', $time);

                    $peer[] = $time . $peer_ip . $peer_port;
                    $peer_num++;
                    }
                }
                break;
        }
    $cnt++;
    }

    if ($_GET['compact']!=1)
    $resp .= 'ee';
    else
    {
    for($i=0;$i<$peer_num;$i++)
        {
            $o .= substr($peer[$i], 1, 6);
        }
        $resp .= strlen($o) . ':' . $o . 'e' ;
    }


    // now we add the peer to the current list of peers:
    rewind($source);
    $row['seeders'] = 0;
    $row['leechers'] = 0;

    if ($seeder == 1)
    $row['seeders'] += 1;
    else
    $row['leechers'] += 1;


    // bitcomet is causing some trouble here, we need to make this to sort this issue
    if (substr($peer_id, 0, 4) == "exbc")
    {
     //bitcomet peer_id detected
     $peer_id = "exbcA".substr($peer_id, 5, 20);
    }

    if ($event != 'stopped')
    $content = sprintf("%s %s %s %d %d %d %d %d %d\n",$ip, $info_hash, str_replace(" ","_",$peer_id),$port,$seeder,$uploaded,$downloaded,$left,strtotime("now"));

    while ($info = fscanf ($source, "%s %s %s %d %d %d %d %d %d\n")) {
    list ($prev_ip, $prev_info_hash, $prev_peer_id,$prev_port,$prev_seeder,$prev_uploaded,$prev_downloaded,$prev_left,$prev_last_action) = $info;

        // we do not add old peers and duplicate peers
        if (floor((strtotime('now') - $prev_last_action) / 60) < 60 && $prev_peer_id != $peer_id)
        {
            $content .= sprintf("%s %s %s %d %d %d %d %d %d\n",$prev_ip, $prev_info_hash, $prev_peer_id,$prev_port,$prev_seeder,$prev_uploaded,$prev_downloaded,$prev_left,$prev_last_action);
            if ($prev_seeder == 1)
            $row['seeders'] += 1;
            else
            $row['leechers'] += 1;
        }
    }
    //flock($source, LOCK_UN);
    //fclose($source);

    // we update the hit counter for this torrent
    //$destination = fopen('data/'.$info_hash.'.dat','w');
    //flock($destination, LOCK_EX) ;
    rewind($source);
    ftruncate($source,0);
    fwrite($source, $content);
    flock($source, LOCK_UN);
    fclose($source);



    // we check if the info_hash is in database
    $source = fopen('data/torrents.dat','r+');
    flock($source, LOCK_EX) ;
    $content = '';
    while ($info = fscanf ($source, "%s %s %s %d %d %s %s %d %d %d %d\n")) {
    list ($prev_info_hash, $filename, $name,$size,$numfiles,$descr,$category,$seeders,$leechers,$completed,$hits) = $info;
     if ($info_hash ==  $prev_info_hash)
     {
        $content .= sprintf("%s %s %s %d %d %s %s %d %d %d %d\n",$prev_info_hash, $filename, $name,$size,$numfiles,$descr,$category,$row['seeders'],$row['leechers'],$row['completed'],$hits);
     }
     else
     $content .= sprintf("%s %s %s %d %d %s %s %d %d %d %d\n",$prev_info_hash, $filename, $name,$size,$numfiles,$descr,$category,$seeders,$leechers,$completed,$hits);
    }


    // we update the hit counter for this torrent
    rewind($source);
    ftruncate($source,0);
    fwrite($source, $content);
    flock($source, LOCK_UN);
    fclose($source);


    // finally we send the data to the client
    benc_resp_raw($resp);




?>